// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _StringSgProcessorsRefExpAVLMap_h
#ifdef __GNUG__
#pragma interface
#endif
#define _StringSgProcessorsRefExpAVLMap_h 1

#include "processorsMap.h"

struct StringSgProcessorsRefExpAVLNode
{
  StringSgProcessorsRefExpAVLNode*      lt;
  StringSgProcessorsRefExpAVLNode*      rt;
  String                 item;
  SgProcessorsRefExp                 cont;
  char                stat;
                      StringSgProcessorsRefExpAVLNode(String& h, SgProcessorsRefExp& c, 
                                    StringSgProcessorsRefExpAVLNode* l=0, StringSgProcessorsRefExpAVLNode* r=0);
                      ~StringSgProcessorsRefExpAVLNode();
};

inline StringSgProcessorsRefExpAVLNode::StringSgProcessorsRefExpAVLNode(String& h, SgProcessorsRefExp& c, 
                                    StringSgProcessorsRefExpAVLNode* l, StringSgProcessorsRefExpAVLNode* r)
     :item(h), cont(c), lt(l), rt(r), stat(0) {}

inline StringSgProcessorsRefExpAVLNode::~StringSgProcessorsRefExpAVLNode() {}

typedef StringSgProcessorsRefExpAVLNode* StringSgProcessorsRefExpAVLNodePtr;


class StringSgProcessorsRefExpAVLMap : public StringSgProcessorsRefExpMap
{
protected:
  StringSgProcessorsRefExpAVLNode*   root;

  StringSgProcessorsRefExpAVLNode*   leftmost();
  StringSgProcessorsRefExpAVLNode*   rightmost();
  StringSgProcessorsRefExpAVLNode*   pred(StringSgProcessorsRefExpAVLNode* t);
  StringSgProcessorsRefExpAVLNode*   succ(StringSgProcessorsRefExpAVLNode* t);
  void            _kill(StringSgProcessorsRefExpAVLNode* t);
  void            _add(StringSgProcessorsRefExpAVLNode*& t);
  void            _del(StringSgProcessorsRefExpAVLNode* p, StringSgProcessorsRefExpAVLNode*& t);

public:
                StringSgProcessorsRefExpAVLMap(SgProcessorsRefExp& dflt);
                StringSgProcessorsRefExpAVLMap(StringSgProcessorsRefExpAVLMap& a);
                ~StringSgProcessorsRefExpAVLMap();

  SgProcessorsRefExp&          operator [] (String& key);

  void          del(String& key);

  Pix           first();
  void          next(Pix& i);
  String&          key(Pix i);
  SgProcessorsRefExp&          contents(Pix i);

  Pix           seek(String& key);
  int           contains(String& key);

  void          clear(); 

  Pix           last();
  void          prev(Pix& i);

  int           OK();
};

inline StringSgProcessorsRefExpAVLMap::~StringSgProcessorsRefExpAVLMap()
{
  _kill(root);
}

inline StringSgProcessorsRefExpAVLMap::StringSgProcessorsRefExpAVLMap(SgProcessorsRefExp& dflt) :StringSgProcessorsRefExpMap(dflt)
{
  root = 0;
}

inline Pix StringSgProcessorsRefExpAVLMap::first()
{
  return Pix(leftmost());
}

inline Pix StringSgProcessorsRefExpAVLMap::last()
{
  return Pix(rightmost());
}

inline void StringSgProcessorsRefExpAVLMap::next(Pix& i)
{
  if (i != 0) i = Pix(succ((StringSgProcessorsRefExpAVLNode*)i));
}

inline void StringSgProcessorsRefExpAVLMap::prev(Pix& i)
{
  if (i != 0) i = Pix(pred((StringSgProcessorsRefExpAVLNode*)i));
}

inline String& StringSgProcessorsRefExpAVLMap::key(Pix i)
{
  if (i == 0) error("null Pix");
  return ((StringSgProcessorsRefExpAVLNode*)i)->item;
}

inline SgProcessorsRefExp& StringSgProcessorsRefExpAVLMap::contents(Pix i)
{
  if (i == 0) error("null Pix");
  return ((StringSgProcessorsRefExpAVLNode*)i)->cont;
}

inline void StringSgProcessorsRefExpAVLMap::clear()
{
  _kill(root);
  count = 0;
  root = 0;
}

inline int StringSgProcessorsRefExpAVLMap::contains(String& key)
{
  return seek(key) != 0;
}

#endif
