// This file may look like C but it is really -*- C++ -*-

// Please see the COPYRIGHT_and_DISCLAIMER file in the top level
// directory of the distribution regarding the provisions under
// which this software is distributed

// This may look like C code, but it is really -*- C++ -*-
// WARNING: This file is obsolete.  Use ../SLList.cc, if you can.
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifdef __GNUG__
// #pragma implementation
#endif
#include <values.h>
#include <stream.h>
#ifdef __GNUG__
#include <builtin.h>
#endif
#include "sage++user.h"
#include "SgStmtPtr.SLList.h"

void SgStmtPtrSLList::error(const char* msg)
{
#ifdef __GNUG__
  (*lib_error_handler)("SLList", msg);
#else
  printf("SLList error: %s\n");
#endif
}

int SgStmtPtrSLList::length()
{
  int l = 0;
  SgStmtPtrSLListNode* t = last;
  if (t != 0) do { ++l; t = t->tl; } while (t != last);
  return l;
}

SgStmtPtrSLList::SgStmtPtrSLList(const SgStmtPtrSLList& a)
{
  if (a.last == 0)
    last = 0;
  else
  {
    SgStmtPtrSLListNode* p = a.last->tl;
    SgStmtPtrSLListNode* h = new SgStmtPtrSLListNode(p->hd);
    last = h;
    for (;;)
    {
      if (p == a.last)
      {
        last->tl = h;
        return;
      }
      p = p->tl;
      SgStmtPtrSLListNode* n = new SgStmtPtrSLListNode(p->hd);
      last->tl = n;
      last = n;
    }
  }
}

SgStmtPtrSLList& SgStmtPtrSLList::operator = (const SgStmtPtrSLList& a)
{
  if (last != a.last)
  {
    clear();
    if (a.last != 0)
    {
      SgStmtPtrSLListNode* p = a.last->tl;
      SgStmtPtrSLListNode* h = new SgStmtPtrSLListNode(p->hd);
      last = h;
      for (;;)
      {
        if (p == a.last)
        {
          last->tl = h;
          break;
        }
        p = p->tl;
        SgStmtPtrSLListNode* n = new SgStmtPtrSLListNode(p->hd);
        last->tl = n;
        last = n;
      }
    }
  }
  return *this;
}

void SgStmtPtrSLList::clear()
{
  if (last == 0)
    return;

  SgStmtPtrSLListNode* p = last->tl;
  last->tl = 0;
  last = 0;

  while (p != 0)
  {
    SgStmtPtrSLListNode* nxt = p->tl;
    delete(p);
    p = nxt;
  }
}


Pix SgStmtPtrSLList::prepend(SgStmtPtr& item)
{
  SgStmtPtrSLListNode* t = new SgStmtPtrSLListNode(item);
  if (last == 0)
    t->tl = last = t;
  else
  {
    t->tl = last->tl;
    last->tl = t;
  }
  return Pix(t);
}


Pix SgStmtPtrSLList::prepend(SgStmtPtrSLListNode* t)
{
  if (t == 0) return 0;
  if (last == 0)
    t->tl = last = t;
  else
  {
    t->tl = last->tl;
    last->tl = t;
  }
  return Pix(t);
}


Pix SgStmtPtrSLList::append(SgStmtPtr& item)
{
  SgStmtPtrSLListNode* t = new SgStmtPtrSLListNode(item);
  if (last == 0)
    t->tl = last = t;
  else
  {
    t->tl = last->tl;
    last->tl = t;
    last = t;
  }
  return Pix(t);
}

Pix SgStmtPtrSLList::append(SgStmtPtrSLListNode* t)
{
  if (t == 0) return 0;
  if (last == 0)
    t->tl = last = t;
  else
  {
    t->tl = last->tl;
    last->tl = t;
    last = t;
  }
  return Pix(t);
}

void SgStmtPtrSLList::join(SgStmtPtrSLList& b)
{
  SgStmtPtrSLListNode* t = b.last;
  b.last = 0;
  if (last == 0)
    last = t;
  else if (t != 0)
  {
    SgStmtPtrSLListNode* f = last->tl;
    last->tl = t->tl;
    t->tl = f;
    last = t;
  }
}

Pix SgStmtPtrSLList::ins_after(Pix p, SgStmtPtr& item)
{
  SgStmtPtrSLListNode* u = (SgStmtPtrSLListNode*)p;
  SgStmtPtrSLListNode* t = new SgStmtPtrSLListNode(item);
  if (last == 0)
    t->tl = last = t;
  else if (u == 0) // ins_after 0 means prepend
  {
    t->tl = last->tl;
    last->tl = t;
  }
  else
  {
    t->tl = u->tl;
    u->tl = t;
    if (u == last) 
      last = t;
  }
  return Pix(t);
}


void SgStmtPtrSLList::del_after(Pix p)
{
  SgStmtPtrSLListNode* u = (SgStmtPtrSLListNode*)p;
  if (last == 0 || u == last) error("cannot del_after last");
  if (u == 0) u = last; // del_after 0 means delete first
  SgStmtPtrSLListNode* t = u->tl;
  if (u == t)
    last = 0;
  else
  {
    u->tl = t->tl;
    if (last == t)
      last = u;
  }
  delete t;
}

int SgStmtPtrSLList::owns(Pix p)
{
  SgStmtPtrSLListNode* t = last;
  if (t != 0 && p != 0)
  {
    do
    {
      if (Pix(t) == p) return 1;
      t = t->tl;
    } while (t != last);
  }
  return 0;
}

SgStmtPtr SgStmtPtrSLList::remove_front()
{
  if (last == 0) error("remove_front of empty list");
  SgStmtPtrSLListNode* t = last->tl;
  SgStmtPtr res = t->hd;
  if (t == last)
    last = 0;
  else
    last->tl = t->tl;
  delete t;
  return res;
}

int SgStmtPtrSLList::remove_front(SgStmtPtr& x)
{
  if (last == 0)
    return 0;
  else
  {
    SgStmtPtrSLListNode* t = last->tl;
    x = t->hd;
    if (t == last)
      last = 0;
    else
      last->tl = t->tl;
    delete t;
    return 1;
  }
}


void SgStmtPtrSLList::del_front()
{
  if (last == 0) error("del_front of empty list");
  SgStmtPtrSLListNode* t = last->tl;
  if (t == last)
    last = 0;
  else
    last->tl = t->tl;
  delete t;
}

int SgStmtPtrSLList::OK()
{
  int v = 1;
  if (last != 0)
  {
    SgStmtPtrSLListNode* t = last;
    long count = MAXLONG;      // Lots of chances to find last!
    do
    {
      count--;
      t = t->tl;
    } while (count > 0 && t != last);
    v &= count > 0;
  }
  if (!v) error("invariant failure");
  return v;
}
