// This file may look like C but it is really -*- C++ -*-

// Please see the COPYRIGHT_and_DISCLAIMER file in the top level
// directory of the distribution regarding the provisions under
// which this software is distributed

// This may look like C code, but it is really -*- C++ -*-
// WARNING: This file is obsolete.  Use ../SLList.h, if you can.
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _SgStmtPtrSLList_h
#ifdef __GNUG__
// #pragma interface
#endif
#define _SgStmtPtrSLList_h 1

#include <Pix.h>
// #include "sage++user.h"

typedef SgStatement* SgStmtPtr;

#ifndef _SgStmtPtrSLListNode_h
#define _SgStmtPtrSLListNode_h 1

struct SgStmtPtrSLListNode
{
  SgStmtPtrSLListNode*         tl;
  SgStmtPtr                    hd;
                         SgStmtPtrSLListNode() { }
                         SgStmtPtrSLListNode(const SgStmtPtr& h, SgStmtPtrSLListNode* t = 0);
                         ~SgStmtPtrSLListNode() { }
};


inline SgStmtPtrSLListNode::SgStmtPtrSLListNode(const SgStmtPtr& h, SgStmtPtrSLListNode* t)
:hd(h), tl(t) {}

typedef SgStmtPtrSLListNode* SgStmtPtrSLListNodePtr;

#endif


class SgStmtPtrSLList
{
protected:
  SgStmtPtrSLListNode*        last;

public:
                        SgStmtPtrSLList();
                        SgStmtPtrSLList(const SgStmtPtrSLList& a);
                        ~SgStmtPtrSLList();

  SgStmtPtrSLList&            operator = (const SgStmtPtrSLList& a);

  int                   empty();
  int                   length();

  void                  clear();

  Pix                   prepend(SgStmtPtr& item);
  Pix                   append(SgStmtPtr& item);

  void                  join(SgStmtPtrSLList&);

  Pix                   prepend(SgStmtPtrSLListNode*);
  Pix                   append(SgStmtPtrSLListNode*);

  SgStmtPtr&                  operator () (Pix p);
  Pix                   first();
  void                  next(Pix& p);
  int                   owns(Pix p);
  Pix                   ins_after(Pix p, SgStmtPtr& item);
  void                  del_after(Pix p);

  SgStmtPtr&                  front();
  SgStmtPtr&                  rear();
  SgStmtPtr                   remove_front();
  int                   remove_front(SgStmtPtr& x);
  void                  del_front();

  void                  error(const char* msg);
  int                   OK();
};

inline SgStmtPtrSLList::~SgStmtPtrSLList()
{
  clear();
}

inline SgStmtPtrSLList::SgStmtPtrSLList()
{
  last = 0;
}

inline int SgStmtPtrSLList::empty()
{
  return last == 0;
}


inline Pix SgStmtPtrSLList::first()
{
  return (last == 0)? 0 : Pix(last->tl);
}

inline void SgStmtPtrSLList::next(Pix& p)
{
  p = (p == 0 || p == last)? 0 : Pix(((SgStmtPtrSLListNode*)(p))->tl);
}

inline SgStmtPtr& SgStmtPtrSLList::operator () (Pix p)
{
  if (p == 0) error("null Pix");
  return ((SgStmtPtrSLListNode*)(p))->hd;
}

inline SgStmtPtr& SgStmtPtrSLList::front()
{
  if (last == 0) error("front: empty list");
  return last->tl->hd;
}

inline SgStmtPtr& SgStmtPtrSLList::rear()
{
  if (last == 0) error("rear: empty list");
  return last->hd;
}

#endif
