// This file may look like C but it is really -*- C++ -*-

// Please see the COPYRIGHT_and_DISCLAIMER file in the top level
// directory of the distribution regarding the provisions under
// which this software is distributed

// FM Number Of Processors Intrinsic

#define FM_N_PROCESSORS_INTRINSIC       "NUMBER_OF_PROCESSORS"
#define FM_N_PROCESSORS_PROC            "fm_number_of_processors"

// FM initialization & shut down

#define FM_INIT_PROC                    "fm_init"
#define FM_START_PROC                   "fm_start"
#define FM_IS_MASTER_VAR                "fm__is_master"
#define FM_SHUTDOWN_PROC                "fm_shutdown"

// processors

#define FM_VC_SHAPE_PROC                "fm_vc_shape"
#define FM_CHILD_VC_OFFSET_PROC         "fm_child_vc_offset"

// Communication  

#define FM_INIT_INPORT_PROC             "fm_init_inport"
#define FM_INIT_INPORT_DEBUG_PROC       "fm_init_inport_debug"
#define FM_INPORT_LEAVING_SCOPE_PROC    "fm_inport_leaving_scope"
#define FM_INIT_OUTPORT_PROC            "fm_init_outport"
#define FM_INIT_OUTPORT_DEBUG_PROC      "fm_init_outport_debug"
#define FM_OUTPORT_LEAVING_SCOPE_PROC   "fm_outport_leaving_scope"
#define FM_CHANNEL_PROC                 "fm_channel"
#define FM_MOVE_INPORT_PROC             "fm_move_inport"
#define FM_MOVE_OUTPORT_PROC            "fm_move_outport"
#define FM_ERROR_MESSAGE_PROC           "fm_error_message"
#define FM_MERGER_INIT_PROC             "fm_merger_init"
#define FM_MERGER_ADD_PROC              "fm_merger_add"
#define FM_MERGER_DONE_PROC             "fm_merger_done"
#define FM_END_CHANNEL_PROC             "fm_end_channel"
#define FM_PROBE_PROC                   "fm_probe"

// Concurrency

#define FM_PBLOCK_INIT_PROC             "fm_pblock_init"
#define FM_PBLOCK_SPAWN_PROC            "fm_spawn"
#define FM_PBLOCK_RESET_PROC            "fm_pblock_reset"
#define FM_PBLOCK_INIT_INVOKE_PROC      "fm_pblock_init_invoke"
#define FM_PBLOCK_INVOKE_PROC           "fm_pblock_invoke"
#define FM_PBLOCK_CONTEXT_WAIT_PROC     "fm_pblock_context_wait"
#define FM_PORT_CREATE_PROC             "fm_port_create"
#define FM_NOTIFY_PORTS_PROC            "fm_notify_ports"
#define FM_PBLOCK_WAIT_PROC             "fm_pblock_wait"

// Pablo Caller Info

#define FM_PABLO_CALLER_INFO_PROC       "fm_pablo_caller_info"

// control flow

#define FM_STOP_PROC                    "fm_stop"

// MPCALL

#define MP_BUFFER_SIZE_SYMB             "fm_mp_buff"
#define MP_BUFFER_DEFAULT_SIZE           1024

// Encoding Key and Prefixes

#define EC_IOVAL                          0
#define EC_CHANNEL                        1
#define EC_PORT                           2
#define EC_PARBLOCK                       3
#define EC_BUFFER                         4
#define EC_DOVAR                          5
#define EC_VEC                            6
#define EC_MPC                            7
#define EC_EMPTY                          8
#define EC_MANGLE                         9


#define FM_PREFIX                       "fm_"

#define EC_IOVAL_PREFIX                 "io"
#define EC_CHANNEL_PREFIX               "ch"
#define EC_PORT_PREFIX                  "pt"
#define EC_PARBLOCK_PREFIX              "pb"
#define EC_BUFFER_PREFIX                "bf"
#define EC_DOVAR_PREFIX                 "di"
#define EC_VEC_PREFIX                   "vc"
#define EC_EMPTY_PREFIX                 "ep"

// fm_vec 

#define VEC_NO_ANNOTATION                0
#define VEC_LOCATION                     1
#define VEC_SUBMACHINE                   2

// compiler error and warning string length

#define FM_ERROR_STRING_LENGTH           512
#define FM_WARNING_STRING_LENGTH         512

// Map Macros

#define portMapSet                       stmtMapSet
#define portMapGet                       stmtMapGet

#define portTypeMapSet                   exprMapSet
#define portTypeMapGet                   exprMapGet
#define typeMapSet                       exprMapSet
#define typeMapGet                       exprMapGet
#define parameterMapSet                  exprMapSet
#define parameterMapGet                  exprMapGet
#define intentMapSet                     exprMapSet
#define intentMapGet                     exprMapGet
#define processorsMapSet                 exprMapSet
#define processorsMapGet                 exprMapGet

#define typeMapOverwrite                 exprMapOverwrite
#define intentMapOverwrite               exprMapOverwrite

#define EXPR_HAS_F90_ARRAY_SECTION       is_f90_array_section_reference

// 
// FM Compiler Assertion
//
#define fm_assert(expression) \
  ((void) ((expression) ? 0 : _fm_assert (expression,__FILE__, __LINE__)))

#define _fm_assert(expression,file,lineno) \
  (printf ("FM failed assertion at %s:%d\n",file,lineno), \
   abort(), 0)

//
// port macros
//

#define IS_INPORT_DECL(stmt) (stmt->variant() == INPORT_DECL)
#define IS_OUTPORT_DECL(stmt) (stmt->variant() == OUTPORT_DECL)

#define EXPR_LIST_VALUE(e) (e->variant()==EXPR_LIST)? isSgExprListExp(e)->value() : e

