// This file may look like C but it is really -*- C++ -*-

// Please see the COPYRIGHT_and_DISCLAIMER file in the top level
// directory of the distribution regarding the provisions under
// which this software is distributed

#include "fmc_defs.h"
#include "global.h"

void doIntentStmt(SgStatement *s)
{
    SgIntentStmt                *intentStmt;
    SgExpression                *attribute;
    int                          i;

    intentStmt = isSgIntentStmt(s);
    attribute  = intentStmt->attribute();

    //
    // add each variable to the intent map
    //
    for (i = 0; i < intentStmt->numberOfArgs(); i++) {
	SgExpression            *arg;

	arg = intentStmt->arg(i);
//	printf("arg(%d) == %s\n", i, arg->symbol()->identifier());
	if (arg->symbol()) {
	    intentMapSet(intentMap, arg->symbol()->identifier(), attribute);
	} else {
	    fm_internal_error("\
Expect a non-null symbol for an intent statement at %s:%d", 
			      __FILE__, __LINE__);
	}
    }
    fmStmtSLL.append(s);
}


