// This file may look like C but it is really -*- C++ -*-

// Please see the COPYRIGHT_and_DISCLAIMER file in the top level
// directory of the distribution regarding the provisions under
// which this software is distributed

// this may look like C but it is really -*- c++ -*-

// Please see the COPYRIGHT_and_DISCLAIMER file in the top level
// directory of the distribution regarding the provisions under
// which this software is distributed

#include "fmc_defs.h"
#include "global.h"


void doMoveportStmt(SgStatement *s)
{
    SgMoveportStmt *moveportStmt = isSgMoveportStmt(s);
    SgExpression   *from, *to;
    SgExpression   *ioStore, *errLabel;
    SgCallStmt     *callStmt;
    SgExpression   *ioArg;
    int            from_port_variant, to_port_variant;

    fm_assert(moveportStmt);
    from     = portExp(moveportStmt->fromport());
    to       = portExp(moveportStmt->toport());

    //
    // check whether both from and to are
    // either all inports or all outports
    //

    from_port_variant = getPortVariant(from);
    to_port_variant   = getPortVariant(to);

    if (from_port_variant != INPORT_DECL 
	&& from_port_variant != OUTPORT_DECL)
    {
	fm_error(s, "invalid FROM= specifier, %s is not a port variable", 
		 (from->symbol())->identifier());
	return;
    } else if (to_port_variant != INPORT_DECL 
	&&  to_port_variant != OUTPORT_DECL) 
    {
	fm_error(s, "invalid TO= specifier, %s is not a port variable",
		 (to->symbol())->identifier());
	return;
    } else if (from_port_variant != to_port_variant) {
	fm_error(s, "\
attempt to perform moveport on two different ports, \
%s is an %sport but %s is an %sport", 
		 (portExp(from)->symbol())->identifier(),
		 (from_port_variant == INPORT_DECL)? "in" : "out",
		 (portExp(to)->symbol())->identifier(),
		 (to_port_variant  == INPORT_DECL)? "in" : "out");
	return;
    } 

    //
    // Check to see whether two ports
    // has the same porttypes
    //
    if (! eqPortTypeCiList(from,to)) {
	return;
    }

//    if (! eqPortTypeCiList(from,to)) {
//	fm_error(s, "from port and to port are of different types");
//    }

    ioStore  = moveportStmt->ioStore();
    errLabel = moveportStmt->errLabel();
    
    //
    // generate fm_move_{in|out}port calls
    //
    //
    callStmt = new SgCallStmt((from_port_variant==INPORT_DECL)?
			      *fmMoveInportCallSymb : *fmMoveOutportCallSymb);

    callStmt->addArg(*from);
    callStmt->addArg(*to);
    ioArg = fmIOVarExp(ioStore);
    callStmt->addArg(*ioArg);
    s->insertStmtBefore(*callStmt);
    s->insertStmtBefore(*checkIOStat(1,ioStore,ioArg,errLabel));

    fmStmtSLL.append(s);
}

SgExpression *makeIOStoreVarRef(SgExpression *ioStore)
{
    char *ident;
    if (! ioStore) {
	SgSymbol    *ioStoreSymb;
	SgVarRefExp *ioStoreRef;

	ident = encodeStr(EC_IOVAL);
	ioStoreSymb = new SgVariableSymb(ident, *integer_t);
	ioStoreSymb->declareTheSymbol(*currentProcedure);
	
	if (opt_use_auto_vars) 
	  declare_auto_symb(ident, currentProcedure);

	ioStoreRef = new SgVarRefExp(*ioStoreSymb);
	return(ioStoreRef);
    } else {
	return(ioStore);
    }
}

    
