// This file may look like C but it is really -*- C++ -*-

// Please see the COPYRIGHT_and_DISCLAIMER file in the top level
// directory of the distribution regarding the provisions under
// which this software is distributed

#include "global.h"
#include <assert.h>
#include <String.h>

SgStatement *getEndParStmt(SgStatement *);
void doProsCallStmt(SgStatement *, SgStatement *, int, SgVarRefExp *);

#if 0
void doProcessDoStmt(SgStatement *s, 
		     SgStatement *where, 
		     int phase,
		     SgVarRefExp *fm_pblock,
		     SgVarRefExp *fm_buffer,
		     SgVarRefExp *fm_ports)
#endif /* 0 */

void doProcessDoStmt(SgStatement *s, 
		     SgStatement *where, 
		     int phase,
		     SgVarRefExp *fm_pblock)
{
    SgProcessDoStmt *processDoStmt = isSgProcessDoStmt(s);
    SgStatement *endParDo = getEndParStmt(s);
    SgStatement *line;
    SgForStmt *forStmt;
    SgContinueStmt *cont = new SgContinueStmt;
    SgStatement *lsp;

    assert(processDoStmt);
    
    // Create a Fortran Do Loop
    if (processDoStmt->step()) {
	forStmt = new SgForStmt(*processDoStmt->symbol(),
				*processDoStmt->start(),
				*processDoStmt->end(),
				*processDoStmt->step(),
				*cont);
    } else {
	forStmt = new SgForStmt(*processDoStmt->symbol(),
				*processDoStmt->start(),
				*processDoStmt->end(),
				*cont);
    }
//    forStmt->unparsestdout();
    where->insertStmtBefore(*forStmt);
    lsp = s;
    for (line = s->lexNext(); lsp != endParDo; line = lsp->lexNext()) {
	switch (line->variant()) {
	  case PROS_STAT:
	  case PROS_STAT_LCTN:
	  case PROS_STAT_SUBM:
#if 0
	    doProsCallStmt(line,
			   cont,
			   phase,
			   fm_pblock,
			   fm_buffer,
			   fm_ports);
#endif /* 0 */
	    doProsCallStmt(line,
			   cont,
			   phase,
			   fm_pblock);

	    lsp = line;
	    break;
	  case PROCESS_DO_STAT:
	    doProcessDoStmt(line,cont,phase,fm_pblock);
	    lsp = getEndParStmt(line);
	    break;
	  default:
	    lsp = line;
	    break;
	    // fm_error:
	    // has already complained before
	}
    }
    // change to a normal Fortran do-loop
    //    s->setVariant(FOR_NODE);

    // append to fmStmtList
    cont->deleteStmt();
//    fmStmtSLL.append(s);
}

